/*
 * Created on 08-Sep-2005
 * Created by Paul Gardner
 * Copyright (C) 2005 Aelitis, All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * AELITIS, SARL au capital de 30,000 euros
 * 8 Allee Lenotre, La Grille Royale, 78600 Le Mesnil le Roi, France.
 *
 */

package org.parg.azureus.plugins.sudoku;

import org.parg.azureus.plugins.sudoku.model.SudokuModel;
import org.parg.azureus.plugins.sudoku.model.SudokuModelFactory;
import org.parg.azureus.plugins.sudoku.ui.swing.SudokuUIJFrame;

public class 
Main 
{
	private static int[][] test_values0 = 
	{		{ 0,0,0, 0,0,0, 0,0,0 },
			{ 0,0,0, 0,0,0, 0,0,0 },
			{ 0,0,0, 0,0,0, 0,0,0 },
			
			{ 0,0,0, 0,0,0, 0,0,0 },
			{ 0,0,0, 0,0,0, 0,0,0 },
			{ 0,0,0, 0,0,0, 0,0,0 },
			
			{ 0,0,0, 0,0,0, 0,0,0 },
			{ 0,0,0, 0,0,0, 0,0,0 },
			{ 0,0,0, 0,0,0, 0,0,0 },
	};
	
	private static int[][] test_values_debug = 
	{		{ 8,0,0, 0,4,0, 1,0,3 },
			{ 0,0,0, 5,0,0, 7,0,0 },
			{ 1,0,3, 0,0,0, 0,0,0 },
			
			{ 0,0,0, 0,0,0, 0,0,0 },
			{ 0,0,0, 0,0,0, 0,0,0 },
			{ 0,0,0, 0,0,0, 0,0,0 },
			
			{ 0,0,0, 0,0,0, 0,0,0 },
			{ 0,0,0, 0,0,0, 0,0,0 },
			{ 0,0,0, 0,0,0, 0,0,0 },
	};
	private static int[][] test_values_mild_23 = 
	{		{ 1,0,0, 9,0,0, 6,7,0 },
			{ 0,0,0, 4,0,0, 0,1,3 },
			{ 0,9,0, 0,2,0, 0,0,0 },
			
			{ 0,0,0, 5,7,2, 0,3,0 },
			{ 3,0,0, 0,0,0, 0,0,5 },
			{ 0,2,0, 3,9,4, 0,0,0 },
			
			{ 0,0,0, 0,4,0, 0,2,0 },
			{ 2,6,0, 0,0,5, 0,0,0 },
			{ 0,8,5, 0,0,3, 0,0,9 },
	};
	
	private static int[][] test_values_fiendish_96 = 
	{		{ 0,0,7, 3,0,0, 2,0,0 },
			{ 3,0,0, 0,0,0, 0,0,1 },
			{ 8,0,0, 6,2,0, 0,0,0 },
			
			{ 0,7,3, 4,0,0, 0,0,5 },
			{ 0,0,0, 0,0,0, 0,0,0 },
			{ 5,0,0, 0,0,8, 4,9,0 },
			
			{ 0,0,0, 0,6,7, 0,0,4 },
			{ 2,0,0, 0,0,0, 0,0,6 },
			{ 0,0,9, 0,0,4, 3,0,0 },
	};
	
	private static int[][] test_values_fiendish_97 = 
	{		{ 0,3,0, 0,0,0, 7,4,0 },
			{ 0,0,0, 0,0,0, 0,8,0 },
			{ 0,0,0, 4,8,5, 6,2,0 },
			
			{ 2,0,0, 0,0,9, 0,0,0 },
			{ 0,6,0, 1,0,4, 0,3,0 },
			{ 0,0,0, 8,0,0, 0,0,9 },
			
			{ 0,9,6, 7,3,1, 0,0,0 },
			{ 0,2,0, 0,0,0, 0,0,0 },
			{ 0,1,7, 0,0,0, 0,6,0 },
	};
	public static void
	main(
		String[]	args )
	{
		SudokuModel model = SudokuModelFactory.create();

		// model.load( test_values_fiendish_96 );

		// model.generate();
		
		new SudokuUIJFrame(model);
	}
}
