/*
 * Created on 09-Sep-2005
 * Created by Paul Gardner
 * Copyright (C) 2005 Aelitis, All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * AELITIS, SARL au capital de 30,000 euros
 * 8 Allee Lenotre, La Grille Royale, 78600 Le Mesnil le Roi, France.
 *
 */

package org.parg.azureus.plugins.sudoku.model;

public interface 
SudokuPossibilityMetric 
	extends Cloneable
{
	public static final int MT_ALREADY_IN_CHUNK				= 0;
	public static final int MT_ALREADY_IN_SLICE				= 1;
	public static final int MT_CHUNK_TUPLE_EXCLUSION		= 2;
	public static final int MT_SLICE_TUPLE_EXCLUSION		= 3;
	public static final int MT_CHUNK_TUPLE_REDUCTION		= 4;
	public static final int MT_SLICE_TUPLE_REDUCTION		= 5;
	public static final int MT_SLICE_DICE_RESTRICTION		= 6;
	public static final int MT_X_WING						= 7;
	public static final int MT_CHAIN						= 8;
	
	public static final String[] MT_NAMES = {
		"in chunk",
		"in slice",
		"chunk tuple exclusion",
		"slice tuple exclusion",
		"chunk tuple reduction",
		"slice tuple reduction",
		"slice dice restriction",
		"x-wing",
		"chain"
	};
	
	public int
	getType();
	
	public String
	getReason();
	
	public int[]
	getParameters();
	
	public Object
	clone();
}
