/*
 * Created on 04-Sep-2005
 * Created by Paul Gardner
 * Copyright (C) 2005 Aelitis, All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * AELITIS, SARL au capital de 30,000 euros
 * 8 Allee Lenotre, La Grille Royale, 78600 Le Mesnil le Roi, France.
 *
 */

package org.parg.azureus.plugins.sudoku.model;

public interface 
SudokuValue 
	extends Cloneable
{
	public static final int OT_NONE		= 0;
	public static final int OT_TRUE		= 1;
	public static final int OT_FALSE	= 2;
	
	public boolean
	hasValue();
	
	public int
	getValue();
	
	public SudokuValueMetric
	getValueMetric();
	
	public void
	setValue(
		int					value,
		boolean				explicit );
	
	public boolean
	isExplicit();
	
	public boolean
	isHint();
	
	public void
	clearHint();
	
	public boolean
	isCore();
	
	public void
	setCore(
		boolean	c );

	public int
	getX();
	
	public int
	getY();
	
	public boolean
	isPossible(
		int		value );
	
	public boolean[]
	getPossibles(
		boolean		strict );
		
	public SudokuPossibilityMetric[]
	getPossibleReasons();
	 
	public Object
	exportHints();
	
	public void
	importHints(
		Object	hints );
	
	public boolean[]
	getHintPossibles();
	
	public SudokuPossibilityMetric[]
	getHintPossibleReasons();
	
	public void
	setPossibleOverride(
		int		value,
		int		override_type );
	
	public int[]
	getPossibleOverrides();
	
	public boolean
	isValid();
	
	public Object
	clone();
	
	public void
	reset();
	
	public void
	clear();
	
	public SudokuModel
	getModel();
	
	public void
	addListener(
		SudokuValueListener		listener );
	
	public void
	removeListener(
		SudokuValueListener		listener );
	
	public String
	getString(
		int level );
}
