/*
 * Created on 12-Oct-2005
 * Created by Paul Gardner
 * Copyright (C) 2005 Aelitis, All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * AELITIS, SARL au capital de 30,000 euros
 * 8 Allee Lenotre, La Grille Royale, 78600 Le Mesnil le Roi, France.
 *
 */

package org.parg.azureus.plugins.sudoku.model.impl;

import org.parg.azureus.plugins.sudoku.model.SudokuSolveInstance;

public class 
SudokuSolveInstanceImpl 
	implements SudokuSolveInstance
{
	private boolean	abandoned;
	private boolean for_generation;
	private int		chain_depth;
	
	protected
	SudokuSolveInstanceImpl(
		boolean	_for_generation,
		int		_chain_depth )
	{
		for_generation 	= _for_generation;
		chain_depth		= _chain_depth;
	}
	
	public boolean
	abandoned()
	{
		return( abandoned );
	}
	
	public void
	abandon()
	{
		abandoned	= true;
	}
	
	public boolean
	forGeneration()
	{
		return( for_generation );
	}
	
	public int
	getChainDepth()
	{
		return( chain_depth );
	}
	
	public void
	setChainDepth(
		int		b )
	{
		chain_depth	= b;
	}
}
