/*
 * Created on 04-Sep-2005
 * Created by Paul Gardner
 * Copyright (C) 2005 Aelitis, All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * AELITIS, SARL au capital de 30,000 euros
 * 8 Allee Lenotre, La Grille Royale, 78600 Le Mesnil le Roi, France.
 *
 */

package org.parg.azureus.plugins.sudoku.ui.swing;

import java.awt.BorderLayout;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Toolkit;

import javax.swing.JFrame;
import javax.swing.JScrollPane;

import org.parg.azureus.plugins.sudoku.model.*;

public class 
SudokuUIJFrame 
{
	private SudokuModel	model;
		
	public 
	SudokuUIJFrame(
		SudokuModel		_model )
	{
		model	= _model;
		
		final JFrame	frame = new JFrame( "Sudoku" );
		
		frame.setDefaultCloseOperation( JFrame.DISPOSE_ON_CLOSE );
		
		Container	cont = frame.getContentPane();
		
		cont.setLayout( new BorderLayout());

		SudokuUIMain	main = 
			new SudokuUIMain( 
					model,
					new SudokuUIAdapter()
					{
						public void
						closed()
						{
							frame.dispose();
						}
					});
		
		cont.add( new JScrollPane( main.getComponent()), BorderLayout.CENTER );
		
		frame.pack();
		
		centreComponent( frame, frame.getSize());
		
		frame.setVisible( true );
		
		main.requestFocus();
	}
	
	
	protected void
	centreComponent(
		Component		comp,
		Dimension		size )
	{
		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		
		comp.setLocation( (dim.width - size.getSize().width)/2,
						   (dim.height - size.getSize().height)/2 );
	}	
}
