/*
 * Created on 04-Sep-2005
 * Created by Paul Gardner
 * Copyright (C) 2005 Aelitis, All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * AELITIS, SARL au capital de 30,000 euros
 * 8 Allee Lenotre, La Grille Royale, 78600 Le Mesnil le Roi, France.
 *
 */

package org.parg.azureus.plugins.sudoku.ui.swing;

import java.awt.Dimension;

import java.awt.Point;

import javax.swing.JPanel;

public class 
SudokuUIPanel
	extends JPanel
{
	protected Dimension	fixed_size;
	protected Point		fixed_location;
	
	protected int		minimum_width		= -1;
	protected int		minimum_height		= -1;
		
	public
	SudokuUIPanel()
	{
		super();
	}	

	public void
	setFixedSize(
		Dimension	s )
	{
		fixed_size	= s;
		
		setSize(fixed_size);
	}
	
	public void
	setFixedSize(
		int		width,
		int		height )
	{
		setFixedSize( new Dimension( width, height ));
	}
	
	public void
	setFixedLocation(
		Point		p )
	{
		fixed_location	= p;
		
		setLocation(p);
	}
	
	public void
	setFixedLocation(
		int		x,
		int		y )
	{
		setFixedLocation( new Point( x, y ));
	}
	
	public void
	setMinimumWidth(
		int		_min )
	{
		minimum_width = _min;
		
		setSize( getSize());
	}
	
	public void
	setMinimumHeight(
		int		_min )
	{
		minimum_height = _min;
		
		setSize( getSize());
	}
					
	public Dimension
	getPreferredSize()
	{
		return( fix( super.getPreferredSize()));
	}
	
	public Dimension
	getMinimumSize()
	{
		return(fix( super.getMinimumSize()));
	}
	
	protected Dimension
	fix(
		Dimension	dim )
	{
		int	width	= fixed_size==null||fixed_size.width==-1?dim.width:fixed_size.width;
		int	height	= fixed_size==null||fixed_size.height==-1?dim.height:fixed_size.height;
		
		if ( minimum_width != -1 && width < minimum_width ){
			
			width = minimum_width;
		}
		
		if ( minimum_height != -1 && height < minimum_height ){
			
			height = minimum_height;
		}
		
		return( new Dimension( width, height ));
	}
	
	public void
	setBounds(
		int		_x,
		int		_y,
		int		_width,
		int		_height )
	{
		int	x		= fixed_location==null?_x:fixed_location.x;
		int	y		= fixed_location==null?_y:fixed_location.y;
		
		Dimension temp = fix( new Dimension( _width, _height ));
				
		super.setBounds( x, y, temp.width, temp.height );
	}
}